package tests;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.github.fge.jackson.JsonLoader;
import com.github.fge.jsonschema.core.exceptions.ProcessingException;
import com.github.fge.jsonschema.main.JsonSchema;
import com.github.fge.jsonschema.main.JsonSchemaFactory;
import com.google.common.reflect.TypeToken;
import com.google.gson.Gson;
import io.restassured.RestAssured;
import io.restassured.http.ContentType;
import io.restassured.response.Response;
import net.serenitybdd.core.Serenity;
import net.serenitybdd.junit.runners.SerenityRunner;
import net.serenitybdd.rest.SerenityRest;
import net.thucydides.core.annotations.Title;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import utils.entities.User;

import java.io.IOException;
import java.lang.reflect.Type;
import java.util.List;

@RunWith(SerenityRunner.class)
public class Test_Case_N2_API_testing {

    Response response;

    @Test
    @Title("Test 2a: Check response code is 200")
    public void test_a(){
        SerenityRest
                .get("https://jsonplaceholder.typicode.com/users").then().assertThat().statusCode(200).extract().response();
    }

    @Test
    @Title("Test 2b_1: Try invalid URI")
    public void test_b_1(){
        //try invalid URI
        SerenityRest
                .get("https://jsonplaceholder.typicode.com/users123").then().assertThat().statusCode(404).extract().response();
    }

    @Test
    @Title("Test 2b_2:Try delete method")
    public void test_b_2(){
        //try delete method
        SerenityRest
                .delete("https://jsonplaceholder.typicode.com/users").then().assertThat().statusCode(404);
    }

    @Test
    @Title("Test 2b_3: Try to incorrect body and content type and method")
    public void test_b_3(){
        //try to incorrect body and content type and method
        SerenityRest.given()
                .body("{     \"id\": 2,     \"name\": \"Ervin Howell\",     \"username\": \"Antonette\",   " +
                        "  \"email\": \"Shanna@melissa.tv\",     \"address\": {       \"street\": \"Victor Plains\",   " +
                        "    \"suite\": \"Suite 879\",       \"city\": \"Wisokyburgh\",       \"zipcode\": \"90566-7771\",       \"geo\": {         \"lat\": \"-43.9509\",         \"lng\": \"-34.4618\"       }     }")
                .contentType(ContentType.JSON)
                .post("https://jsonplaceholder.typicode.com/users").then().assertThat().statusCode(500);
    }
    @Ignore("Doesn't work")
    @Test
    @Title("Test 2c: Make JSON validation (JSON schema for comparison should be generated by\n" +
            "yourself in any way convenient for you)")
    public void test_c() throws IOException, ProcessingException {
        String jsons = SerenityRest
                .get("https://jsonplaceholder.typicode.com/users").then().extract().body().asString();
        JsonNode arrNode = new ObjectMapper().readTree(jsons);
        JsonSchemaFactory factory = JsonSchemaFactory.byDefault();
        JsonSchema schema = factory.getJsonSchema(jsonSchema);
        schema.validate(arrNode);

    }

    @Test
    @Title("Test 2d: Check response has 10 JSON objects")
    public void test_d(){
        response = SerenityRest
                .get("https://jsonplaceholder.typicode.com/users").then().extract().response();
        Gson gson = new Gson();
        Type listType = new TypeToken<List<User>>(){}.getType();
        List<User> users = gson.fromJson(response.getBody().asString(), listType);
        Assert.assertEquals("Wrong size of users list",10, users.size());
    }


    static String jsonSchema = "{\n" +
            "  \"definitions\": {},\n" +
            "  \"$schema\": \"http://json-schema.org/draft-07/schema#\",\n" +
            "  \"$id\": \"http://example.com/root.json\",\n" +
            "  \"type\": \"object\",\n" +
            "  \"title\": \"The Root Schema\",\n" +
            "  \"required\": [\n" +
            "    \"id\",\n" +
            "    \"name\",\n" +
            "    \"username\",\n" +
            "    \"email\",\n" +
            "    \"address\",\n" +
            "    \"phone\",\n" +
            "    \"website\",\n" +
            "    \"company\"\n" +
            "  ],\n" +
            "  \"properties\": {\n" +
            "    \"id\": {\n" +
            "      \"$id\": \"#/properties/id\",\n" +
            "      \"type\": \"integer\",\n" +
            "      \"title\": \"The Id Schema\",\n" +
            "      \"default\": 0,\n" +
            "      \"examples\": [\n" +
            "        1\n" +
            "      ]\n" +
            "    },\n" +
            "    \"name\": {\n" +
            "      \"$id\": \"#/properties/name\",\n" +
            "      \"type\": \"string\",\n" +
            "      \"title\": \"The Name Schema\",\n" +
            "      \"default\": \"\",\n" +
            "      \"examples\": [\n" +
            "        \"Leanne Graham\"\n" +
            "      ],\n" +
            "      \"pattern\": \"^(.*)$\"\n" +
            "    },\n" +
            "    \"username\": {\n" +
            "      \"$id\": \"#/properties/username\",\n" +
            "      \"type\": \"string\",\n" +
            "      \"title\": \"The Username Schema\",\n" +
            "      \"default\": \"\",\n" +
            "      \"examples\": [\n" +
            "        \"Bret\"\n" +
            "      ],\n" +
            "      \"pattern\": \"^(.*)$\"\n" +
            "    },\n" +
            "    \"email\": {\n" +
            "      \"$id\": \"#/properties/email\",\n" +
            "      \"type\": \"string\",\n" +
            "      \"title\": \"The Email Schema\",\n" +
            "      \"default\": \"\",\n" +
            "      \"examples\": [\n" +
            "        \"Sincere@april.biz\"\n" +
            "      ],\n" +
            "      \"pattern\": \"^(.*)$\"\n" +
            "    },\n" +
            "    \"address\": {\n" +
            "      \"$id\": \"#/properties/address\",\n" +
            "      \"type\": \"object\",\n" +
            "      \"title\": \"The Address Schema\",\n" +
            "      \"required\": [\n" +
            "        \"street\",\n" +
            "        \"suite\",\n" +
            "        \"city\",\n" +
            "        \"zipcode\",\n" +
            "        \"geo\"\n" +
            "      ],\n" +
            "      \"properties\": {\n" +
            "        \"street\": {\n" +
            "          \"$id\": \"#/properties/address/properties/street\",\n" +
            "          \"type\": \"string\",\n" +
            "          \"title\": \"The Street Schema\",\n" +
            "          \"default\": \"\",\n" +
            "          \"examples\": [\n" +
            "            \"Kulas Light\"\n" +
            "          ],\n" +
            "          \"pattern\": \"^(.*)$\"\n" +
            "        },\n" +
            "        \"suite\": {\n" +
            "          \"$id\": \"#/properties/address/properties/suite\",\n" +
            "          \"type\": \"string\",\n" +
            "          \"title\": \"The Suite Schema\",\n" +
            "          \"default\": \"\",\n" +
            "          \"examples\": [\n" +
            "            \"Apt. 556\"\n" +
            "          ],\n" +
            "          \"pattern\": \"^(.*)$\"\n" +
            "        },\n" +
            "        \"city\": {\n" +
            "          \"$id\": \"#/properties/address/properties/city\",\n" +
            "          \"type\": \"string\",\n" +
            "          \"title\": \"The City Schema\",\n" +
            "          \"default\": \"\",\n" +
            "          \"examples\": [\n" +
            "            \"Gwenborough\"\n" +
            "          ],\n" +
            "          \"pattern\": \"^(.*)$\"\n" +
            "        },\n" +
            "        \"zipcode\": {\n" +
            "          \"$id\": \"#/properties/address/properties/zipcode\",\n" +
            "          \"type\": \"string\",\n" +
            "          \"title\": \"The Zipcode Schema\",\n" +
            "          \"default\": \"\",\n" +
            "          \"examples\": [\n" +
            "            \"92998-3874\"\n" +
            "          ],\n" +
            "          \"pattern\": \"^(.*)$\"\n" +
            "        },\n" +
            "        \"geo\": {\n" +
            "          \"$id\": \"#/properties/address/properties/geo\",\n" +
            "          \"type\": \"object\",\n" +
            "          \"title\": \"The Geo Schema\",\n" +
            "          \"required\": [\n" +
            "            \"lat\",\n" +
            "            \"lng\"\n" +
            "          ],\n" +
            "          \"properties\": {\n" +
            "            \"lat\": {\n" +
            "              \"$id\": \"#/properties/address/properties/geo/properties/lat\",\n" +
            "              \"type\": \"string\",\n" +
            "              \"title\": \"The Lat Schema\",\n" +
            "              \"default\": \"\",\n" +
            "              \"examples\": [\n" +
            "                \"-37.3159\"\n" +
            "              ],\n" +
            "              \"pattern\": \"^(.*)$\"\n" +
            "            },\n" +
            "            \"lng\": {\n" +
            "              \"$id\": \"#/properties/address/properties/geo/properties/lng\",\n" +
            "              \"type\": \"string\",\n" +
            "              \"title\": \"The Lng Schema\",\n" +
            "              \"default\": \"\",\n" +
            "              \"examples\": [\n" +
            "                \"81.1496\"\n" +
            "              ],\n" +
            "              \"pattern\": \"^(.*)$\"\n" +
            "            }\n" +
            "          }\n" +
            "        }\n" +
            "      }\n" +
            "    },\n" +
            "    \"phone\": {\n" +
            "      \"$id\": \"#/properties/phone\",\n" +
            "      \"type\": \"string\",\n" +
            "      \"title\": \"The Phone Schema\",\n" +
            "      \"default\": \"\",\n" +
            "      \"examples\": [\n" +
            "        \"1-770-736-8031 x56442\"\n" +
            "      ],\n" +
            "      \"pattern\": \"^(.*)$\"\n" +
            "    },\n" +
            "    \"website\": {\n" +
            "      \"$id\": \"#/properties/website\",\n" +
            "      \"type\": \"string\",\n" +
            "      \"title\": \"The Website Schema\",\n" +
            "      \"default\": \"\",\n" +
            "      \"examples\": [\n" +
            "        \"hildegard.org\"\n" +
            "      ],\n" +
            "      \"pattern\": \"^(.*)$\"\n" +
            "    },\n" +
            "    \"company\": {\n" +
            "      \"$id\": \"#/properties/company\",\n" +
            "      \"type\": \"object\",\n" +
            "      \"title\": \"The Company Schema\",\n" +
            "      \"required\": [\n" +
            "        \"name\",\n" +
            "        \"catchPhrase\",\n" +
            "        \"bs\"\n" +
            "      ],\n" +
            "      \"properties\": {\n" +
            "        \"name\": {\n" +
            "          \"$id\": \"#/properties/company/properties/name\",\n" +
            "          \"type\": \"string\",\n" +
            "          \"title\": \"The Name Schema\",\n" +
            "          \"default\": \"\",\n" +
            "          \"examples\": [\n" +
            "            \"Romaguera-Crona\"\n" +
            "          ],\n" +
            "          \"pattern\": \"^(.*)$\"\n" +
            "        },\n" +
            "        \"catchPhrase\": {\n" +
            "          \"$id\": \"#/properties/company/properties/catchPhrase\",\n" +
            "          \"type\": \"string\",\n" +
            "          \"title\": \"The Catchphrase Schema\",\n" +
            "          \"default\": \"\",\n" +
            "          \"examples\": [\n" +
            "            \"Multi-layered client-server neural-net\"\n" +
            "          ],\n" +
            "          \"pattern\": \"^(.*)$\"\n" +
            "        },\n" +
            "        \"bs\": {\n" +
            "          \"$id\": \"#/properties/company/properties/bs\",\n" +
            "          \"type\": \"string\",\n" +
            "          \"title\": \"The Bs Schema\",\n" +
            "          \"default\": \"\",\n" +
            "          \"examples\": [\n" +
            "            \"harness real-time e-markets\"\n" +
            "          ],\n" +
            "          \"pattern\": \"^(.*)$\"\n" +
            "        }\n" +
            "      }\n" +
            "    }\n" +
            "  }\n" +
            "}";
}
